Module java.base
Package java.lang.module

# Enum ModuleDescriptor.Modifier

java.lang.Object
java.lang.Enum<ModuleDescriptor.Modifier>
java.lang.module.ModuleDescriptor.Modifier

All Implemented Interfaces:
  `Serializable`, `Comparable<ModuleDescriptor.Modifier>`, `Constable`

Enclosing class:
  ModuleDescriptor

    public static enum ModuleDescriptor.Modifier
    extends Enum<ModuleDescriptor.Modifier>

A modifier on a module.

Since:
  9
See Also:
  `ModuleDescriptor.modifiers()`

## Nested Class Summary

## Nested classes/interfaces declared in class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant | Description
--- | ---
`AUTOMATIC` | An automatic module.
`MANDATED` | The module was implicitly declared.
`OPEN` | An open module.
`SYNTHETIC` | The module was not explicitly or implicitly declared.

## Method Summary

Modifier and Type | Method | Description
--- | --- | ---
`static ModuleDescriptor.Modifier` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
`static ModuleDescriptor.Modifier[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

### Methods declared in class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### OPEN

public static final ModuleDescriptor.Modifier OPEN
An open module. An open module does not declare any open packages but the resulting module is treated as if all packages are open.

### AUTOMATIC

public static final ModuleDescriptor.Modifier AUTOMATIC
An automatic module. An automatic module is treated as if it exports and opens all packages.

API Note:
  This modifier does not correspond to a module flag in the binary form of a module declaration (`module-info.class`).

### SYNTHETIC

public static final ModuleDescriptor.Modifier SYNTHETIC
The module was not explicitly or implicitly declared.

### MANDATED

public static final ModuleDescriptor.Modifier MANDATED
The module was implicitly declared.

## Method Details

### values

public static ModuleDescriptor.Modifier[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static ModuleDescriptor.Modifier valueOf​(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null